org.apache.jmeter.config.gui

## Class ArgumentsPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - org.apache.jmeter.gui.AbstractJMeterGuiComponent
          - - org.apache.jmeter.config.gui.AbstractConfigGui
            - - org.apache.jmeter.config.gui.ArgumentsPanel

- All Implemented Interfaces:
    ActionListener, ImageObserver, MenuContainer, Serializable, EventListener, Accessible, ClearGui, JMeterGUIComponent, Printable
  Direct Known Subclasses:
    HTTPArgumentsPanel

      public class ArgumentsPanel
      extends AbstractConfigGui
      implements ActionListener

  A GUI panel allowing the user to enter name-value argument pairs. These arguments (or parameters) are usually used to provide configuration values for some other component.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `COLUMN_RESOURCE_NAMES_0`
    `static String` | `COLUMN_RESOURCE_NAMES_1`
    `static String` | `COLUMN_RESOURCE_NAMES_2`
    `protected ObjectTableModel` | `tableModel` The model for the arguments table.

    - ### Fields inherited from class org.apache.jmeter.gui.AbstractJMeterGuiComponent

      `namePanel`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ArgumentsPanel()` Create a new ArgumentsPanel as a standalone component.
    `ArgumentsPanel(boolean disableButtons, String label)` Create a new ArgumentsPanel as an embedded component, using the specified title.
    `ArgumentsPanel(String label)` Create a new ArgumentsPanel as an embedded component, using the specified title.
    `ArgumentsPanel(String label, boolean enableUpDown)` Create a new ArgumentsPanel as an embedded component, using the specified title.
    `ArgumentsPanel(String label, Color bkg)` Create a new ArgumentsPanel with a border and color background
    `ArgumentsPanel(String label, Color bkg, boolean enableUpDown, boolean standalone)` Create a new ArgumentsPanel with a border and color background
    `ArgumentsPanel(String label, Color bkg, boolean enableUpDown, boolean standalone, ObjectTableModel model)` Create a new ArgumentsPanel with a border and color background
    `ArgumentsPanel(String label, Color bkg, boolean enableUpDown, boolean standalone, ObjectTableModel model, boolean disableButtons)` Create a new ArgumentsPanel with a border and color background
    `ArgumentsPanel(String label, Color bkg, boolean enableUpDown, boolean standalone, ObjectTableModel model, boolean disableButtons, Function<String[],Argument> argCreator)` Create a new ArgumentsPanel with a border and color background
    `ArgumentsPanel(String label, Color bkg, boolean enableUpDown, boolean standalone, ObjectTableModel model, Function<String[],Argument> argCreator)` Create a new ArgumentsPanel with a border and color background

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `actionPerformed(ActionEvent e)` Invoked when an action occurs.
    `protected void` | `addArgument()` Add a new argument row to the table.
    `protected void` | `addFromClipboard()`
    `protected void` | `addFromClipboard(String lineDelimiter, String argDelimiter)` Add values from the clipboard
    `protected void` | `checkButtonsStatus()`
    `void` | `clear()` Clear all rows from the table.
    `void` | `clearBorderForMainPanel()` Clear border around "table with arguments".
    `void` | `clearGui()` Provides a default implementation that resets the name field to the value of getStaticLabel(), reset comment and sets enabled to true.
    `void` | `configure(TestElement el)` A newly created component can be initialized with the contents of a Test Element object by calling this method.
    `protected Argument` | `createArgumentFromClipboard(String[] clipboardCols)`
    `TestElement` | `createTestElement()` JMeter test components are separated into a model and a GUI representation.
    `protected void` | `deleteArgument()` Remove the currently selected argument from the table.
    `protected JButton` | `getAddButton()` Get the button used to add rows to the table.
    `protected JButton` | `getDeleteButton()` Get the button used to delete rows from the table.
    `String` | `getLabelResource()` Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language.
    `Collection<String>` | `getMenuCategories()` This is the list of menu categories this gui component will be available under.
    `protected JTable` | `getTable()` Get the table used to enter arguments.
    `protected JLabel` | `getTableLabel()` Get the title label for this component.
    `protected void` | `initializeTableModel()` Initialize the table model used for the arguments table.
    `protected Component` | `makeLabelPanel()` Create a panel containing the title label for the table.
    `protected Argument` | `makeNewArgument()` Create a new Argument object.
    `void` | `modifyTestElement(TestElement args)` GUI components are responsible for populating TestElements they create with the data currently held in the GUI components.
    `protected void` | `sizeColumns(JTable _table)` Resize the table columns to appropriate widths.
    `protected void` | `stopTableEditing()` Stop any editing that is currently being done on the table.
    `static boolean` | `testFunctors()`

    - ### Methods inherited from class org.apache.jmeter.config.gui.AbstractConfigGui

      `createPopupMenu`

    - ### Methods inherited from class org.apache.jmeter.gui.AbstractJMeterGuiComponent

      `configureTestElement, createTitleLabel, getComment, getDocAnchor, getName, getNamePanel, getPrintableComponent, getStaticLabel, isEnabled, makeBorder, makeScrollPane, makeScrollPane, makeTitlePanel, setComment, setEnabled, setName, wrapTitlePanel`

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.jmeter.gui.JMeterGUIComponent

      `canBeAdded`

- - ### Field Detail

    - #### tableModel

          protected transient ObjectTableModel tableModel

      The model for the arguments table.

    - #### COLUMN_RESOURCE_NAMES_0

          public static final String COLUMN_RESOURCE_NAMES_0

      See Also:
        Constant Field Values

    - #### COLUMN_RESOURCE_NAMES_1

          public static final String COLUMN_RESOURCE_NAMES_1

      See Also:
        Constant Field Values

    - #### COLUMN_RESOURCE_NAMES_2

          public static final String COLUMN_RESOURCE_NAMES_2

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### ArgumentsPanel

          public ArgumentsPanel()

      Create a new ArgumentsPanel as a standalone component.

    - #### ArgumentsPanel

          public ArgumentsPanel(String label)

      Create a new ArgumentsPanel as an embedded component, using the specified title.
      Parameters:
        `label` - the title for the component.

    - #### ArgumentsPanel

          public ArgumentsPanel(String label,
                                boolean enableUpDown)

      Create a new ArgumentsPanel as an embedded component, using the specified title.
      Parameters:
        `label` - the title for the component.
        `enableUpDown` - Add up/down buttons

    - #### ArgumentsPanel

          public ArgumentsPanel(boolean disableButtons,
                                String label)

      Create a new ArgumentsPanel as an embedded component, using the specified title.
      Parameters:
        `disableButtons` - Remove Edit all buttons
        `label` - the title for the component.

    - #### ArgumentsPanel

          public ArgumentsPanel(String label,
                                Color bkg)

      Create a new ArgumentsPanel with a border and color background
      Parameters:
        `label` - text for label
        `bkg` - background colour

    - #### ArgumentsPanel

          public ArgumentsPanel(String label,
                                Color bkg,
                                boolean enableUpDown,
                                boolean standalone)

      Create a new ArgumentsPanel with a border and color background
      Parameters:
        `label` - text for label
        `bkg` - background colour
        `enableUpDown` - Add up/down buttons
        `standalone` - is standalone

    - #### ArgumentsPanel

          public ArgumentsPanel(String label,
                                Color bkg,
                                boolean enableUpDown,
                                boolean standalone,
                                ObjectTableModel model)

      Create a new ArgumentsPanel with a border and color background
      Parameters:
        `label` - text for label
        `bkg` - background colour
        `enableUpDown` - Add up/down buttons
        `standalone` - is standalone
        `model` - the table model to use

    - #### ArgumentsPanel

          public ArgumentsPanel(String label,
                                Color bkg,
                                boolean enableUpDown,
                                boolean standalone,
                                ObjectTableModel model,
                                Function<String[],Argument> argCreator)

      Create a new ArgumentsPanel with a border and color background
      Parameters:
        `label` - text for label
        `bkg` - background colour
        `enableUpDown` - Add up/down buttons
        `standalone` - is standalone
        `model` - the table model to use
        `argCreator` - function to create `Argument`s from Strings taken from clipboard

    - #### ArgumentsPanel

          public ArgumentsPanel(String label,
                                Color bkg,
                                boolean enableUpDown,
                                boolean standalone,
                                ObjectTableModel model,
                                boolean disableButtons)

      Create a new ArgumentsPanel with a border and color background
      Parameters:
        `label` - text for label
        `bkg` - background colour
        `enableUpDown` - Add up/down buttons
        `standalone` - is standalone
        `model` - the table model to use
        `disableButtons` - Remove all buttons

    - #### ArgumentsPanel

          public ArgumentsPanel(String label,
                                Color bkg,
                                boolean enableUpDown,
                                boolean standalone,
                                ObjectTableModel model,
                                boolean disableButtons,
                                Function<String[],Argument> argCreator)

      Create a new ArgumentsPanel with a border and color background
      Parameters:
        `label` - text for label
        `bkg` - background colour
        `enableUpDown` - Add up/down buttons
        `standalone` - is standalone
        `model` - the table model to use
        `disableButtons` - Remove all buttons
        `argCreator` - function to create `Argument`s from Strings taken from clipboard

  - ### Method Detail

    - #### getMenuCategories

          public Collection<String> getMenuCategories()

      This is the list of menu categories this gui component will be available under.
      Specified by:
        `getMenuCategories` in interface `JMeterGUIComponent`
      Overrides:
        `getMenuCategories` in class `AbstractConfigGui`
      Returns:
        a Collection of Strings, where each element is one of the constants defined in MenuFactory
      See Also:
        `MenuFactory`

    - #### getLabelResource

          public String getLabelResource()

      Description copied from interface: `JMeterGUIComponent`
      Get the component's resource name, which getStaticLabel uses to derive the component's label in the local language. The resource name is fixed, and does not vary with the selected language. Normally this method should be overridden in preference to overriding getStaticLabel(). However where the resource name is not available or required, getStaticLabel() may be overridden instead.
      Specified by:
        `getLabelResource` in interface `JMeterGUIComponent`
      Returns:
        the resource name

    - #### createTestElement

          public TestElement createTestElement()

      Description copied from interface: `JMeterGUIComponent`
      JMeter test components are separated into a model and a GUI representation. The model holds the data and the GUI displays it. The GUI class is responsible for knowing how to create and initialize with data the model class that it knows how to display, and this method is called when new test elements are created.

      The canonical implementation looks like this:

           public TestElement createTestElement() {
               TestElementXYZ el = new TestElementXYZ();
               modifyTestElement(el);
               return el;
           }

      Specified by:
        `createTestElement` in interface `JMeterGUIComponent`
      Returns:
        the Test Element object that the GUI component represents.

    - #### modifyTestElement

          public void modifyTestElement(TestElement args)

      Description copied from interface: `JMeterGUIComponent`
      GUI components are responsible for populating TestElements they create with the data currently held in the GUI components. This method should overwrite whatever data is currently in the TestElement as it is called after a user has filled out the form elements in the gui with new information.

      The canonical implementation looks like this:

           public void modifyTestElement(TestElement element) {
               element.clear(); // many implementations use this
               configureTestElement(element);
               // Using the element setters (preferred):
               TestElementXYZ xyz = (TestElementXYZ) element;
               xyz.setState(guiState.getText());
               xyz.setCode(guiCode.getText());
               ... other GUI fields ...
               // or directly (do not use unless there is no setter for the field):
               element.setProperty(TestElementXYZ.STATE, guiState.getText())
               element.setProperty(TestElementXYZ.CODE, guiCode.getText())
               ... other GUI fields ...
           }

      Specified by:
        `modifyTestElement` in interface `JMeterGUIComponent`
      Parameters:
        `args` - the TestElement to modify

    - #### configure

          public void configure(TestElement el)

      A newly created component can be initialized with the contents of a Test Element object by calling this method. The component is responsible for querying the Test Element object for the relevant information to display in its GUI.
      Specified by:
        `configure` in interface `JMeterGUIComponent`
      Overrides:
        `configure` in class `AbstractJMeterGuiComponent`
      Parameters:
        `el` - the TestElement to configure

    - #### getTable

          protected JTable getTable()

      Get the table used to enter arguments.
      Returns:
        the table used to enter arguments

    - #### getTableLabel

          protected JLabel getTableLabel()

      Get the title label for this component.
      Returns:
        the title label displayed with the table

    - #### getDeleteButton

          protected JButton getDeleteButton()

      Get the button used to delete rows from the table.
      Returns:
        the button used to delete rows from the table

    - #### getAddButton

          protected JButton getAddButton()

      Get the button used to add rows to the table.
      Returns:
        the button used to add rows to the table

    - #### checkButtonsStatus

          protected void checkButtonsStatus()

    - #### clearGui

          public void clearGui()

      Description copied from class: `AbstractJMeterGuiComponent`
      Provides a default implementation that resets the name field to the value of getStaticLabel(), reset comment and sets enabled to true. Your GUI may need more things cleared, in which case you should override, clear the extra fields, and still call super.clearGui().
      Specified by:
        `clearGui` in interface `ClearGui`
      Overrides:
        `clearGui` in class `AbstractJMeterGuiComponent`

    - #### clear

          public void clear()

      Clear all rows from the table. T.Elanjchezhiyan(chezhiyan@siptech.co.in)

    - #### actionPerformed

          public void actionPerformed(ActionEvent e)

      Invoked when an action occurs. This implementation supports the add and delete buttons.
      Specified by:
        `actionPerformed` in interface `ActionListener`
      Parameters:
        `e` - the event that has occurred

    - #### deleteArgument

          protected void deleteArgument()

      Remove the currently selected argument from the table.

    - #### addArgument

          protected void addArgument()

      Add a new argument row to the table.

    - #### addFromClipboard

          protected void addFromClipboard(String lineDelimiter,
                                          String argDelimiter)

      Add values from the clipboard
      Parameters:
        `lineDelimiter` - Delimiter string to split clipboard into lines
        `argDelimiter` - Delimiter string to split line into key-value pair

    - #### addFromClipboard

          protected void addFromClipboard()

    - #### createArgumentFromClipboard

          protected Argument createArgumentFromClipboard(String[] clipboardCols)

    - #### makeNewArgument

          protected Argument makeNewArgument()

      Create a new Argument object.
      Returns:
        a new Argument object

    - #### stopTableEditing

          protected void stopTableEditing()

      Stop any editing that is currently being done on the table. This will save any changes that have already been made. Needed for subclasses

    - #### initializeTableModel

          protected void initializeTableModel()

      Initialize the table model used for the arguments table.

    - #### testFunctors

          public static boolean testFunctors()

    - #### sizeColumns

          protected void sizeColumns(JTable _table)

      Resize the table columns to appropriate widths.
      Parameters:
        `_table` - the table to resize columns for

    - #### makeLabelPanel

          protected Component makeLabelPanel()

      Create a panel containing the title label for the table.
      Returns:
        a panel containing the title label

    - #### clearBorderForMainPanel

          public void clearBorderForMainPanel()

      Clear border around "table with arguments". Extra border is not required when the panel is already surrounded by a border.

Copyright © 1998-2022 Apache Software Foundation. All Rights Reserved.